Attribute VB_Name = "modFunctions"
Option Explicit

'// Win32 API
Public Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal length As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lparam As Any) As Long
Public Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long


'// API CONSTS
Public Const LB_SETTABSTOPS = &H192
Public Const WM_USER = &H400
Public Const GWL_EXSTYLE As Long = (-20)
Public Const WS_EX_RIGHT As Long = &H1000
Public Const WS_EX_LEFTSCROLLBAR As Long = &H4000

Private Const TBM_GETTOOLTIPS = (WM_USER + 30)
Private Const TTM_ACTIVATE = (WM_USER + 1)

Public Enum AlignConstants
   alignLeft = 0
   alignRight = 1
End Enum

Public Sub CDTRACKEND_SYNCPROC(ByVal handle As Long, ByVal channel As Long, ByVal data As Long, ByVal user As Long)
    
    'CALLBACK FUNCTION !!!
    
    'Similarly in here, write what to do when sync function
    'is called, i.e screen flash etc.
    
    ' NOTE: a sync callback function should be very quick as other
    ' syncs cannot be processed until it has finished.
    ' handle : The sync that has occured
    ' channel: Channel that the sync occured in
    ' data   : Additional data associated with the sync's occurance
    ' user   : The 'user' parameter given when calling BASS_ChannelSetSync */
    'MessageBox frmDemo.hWnd, user, "", vbInformation
    Call frmDemo.PlayNextTrack(user)
    
End Sub

Public Sub CDERROR_SYNCPROC(ByVal handle As Long, ByVal channel As Long, ByVal data As Long, ByVal user As Long)
    
    'CALLBACK FUNCTION !!!
    
    'Similarly in here, write what to do when sync function
    'is called, i.e screen flash etc.
    
    ' NOTE: a sync callback function should be very quick as other
    ' syncs cannot be processed until it has finished.
    ' handle : The sync that has occured
    ' channel: Channel that the sync occured in
    ' data   : Additional data associated with the sync's occurance
    ' user   : The 'user' parameter given when calling BASS_ChannelSetSync */
    Call frmDemo.CDError
    
End Sub


Public Sub HandleError(strCurrentModule, strRoutine, lngErrNumber, strErrDescription)
    MsgBox "Error in routine : " & strRoutine & "in module : " & strCurrentModule & vbCrLf & "Error #" & lngErrNumber & vbCrLf & strErrDescription
End Sub


Public Sub ThrowError(ByVal Message As String, Optional ByVal ErrorNum As Long = -1)
    'Display error dialogues
    If ErrorNum <> -1 Then
        Message = Message & vbCrLf & vbCrLf & "Error Code : " & ErrorNum
    End If
    MsgBox Message, vbOKOnly Or vbCritical, "Error"
End Sub


'// To disable the tooltip that appears when scrolling Slider control.
Public Sub DisableSliderTooltip(lSliderhWnd As Long)
Dim hTips   As Long

    hTips = SendMessage(lSliderhWnd, TBM_GETTOOLTIPS, 0&, ByVal 0&)
    SendMessage hTips, TTM_ACTIVATE, 0&, ByVal 0&

End Sub


Public Sub SetTrackListTabStops()
Dim aTabs(1) As Long

    aTabs(0) = 15
    aTabs(1) = -235
    
    'Clear any existing tabs.
    Call SendMessage(frmDemo.lstTracks.hwnd, LB_SETTABSTOPS, 0&, 0&)
    'Set the tabs.
    Call SendMessage(frmDemo.lstTracks.hwnd, LB_SETTABSTOPS, 2&, aTabs(0))

End Sub
